#include <iostream>
#include "algo.h"
#include "easiest.h"
#include "dfa.h"

using namespace std;

int** DFA::Spvalues(){
	int *Zbox, l = 0, r = 0, i ,j, xx;    //deltabox v gusfieldovi: sp'_{i,x}(P)
	int **deltabox;
	wchar_t x;
	
	Zbox = Fundamental(pattern, pattern, &l, &r);
	
	deltabox = new int*[l_pattern];    //kvazi prechodova funkcia
	for (i = 0; i < l_pattern; i++)
		deltabox[i] = new int[65536];
	
	for (i = 0; i < l_pattern; i++)
		for (j = 0; j < 65536; j++){
			MEM_INC();
//			deltabox[i][j] = -1;		//default = aby sa zacalo porovnavat od 0 v skaredych pripadoch
			deltabox[i][j] = 0;		//default = aby sa zacalo porovnavat od 0 v skaredych pripadoch
		}
	
	for (j = l_pattern - 1; j > 0; j--){		//P[i+1] != x -> sp'_{i,x}(P) = i - j + 1: j je najmensia pozicia
		i = j + Zbox[j] - 1;			//taka, ze j sa mapuje na i (zaciatok Zbox konciaci na i) a zaroven
		x = pattern[Zbox[j]];			//P[Z_j + 1] = x
		xx = (int) x;
		deltabox[i][xx] = Zbox[j];
	}

	delete[] Zbox;

	return deltabox;
}

int DFA::Match(){
	int **deltabox,k,i, xx, count = 0;
	wchar_t x;

	deltabox = Spvalues();

	gettimeofday(&zac, &tz);

	k = 0;
	i = 0;
	while (k + (l_pattern - i - 1) < l_text){
		while(STEP() && (text[k] == pattern[i]) && (i < l_pattern)){
				k++;
				i++;
		}
		if (i == l_pattern) {
			count++;
//			cerr << "match" << k << endl;
		}
			//mismatch na text[k], pattern[i];
			x = text[k];			
			xx = (int) x;
//			k++;
			if (i < l_pattern) k++;					   //zaruceny match na text[k]
//			if (i > 0) i = deltabox[i-1][xx] + 1;	   //a P[sp'_{i,x}]
			if (i > 0) i = deltabox[i-1][xx];	   //a P[sp'_{i,x}]
			else i = 0;				  	//nemame deltabox[-1][x], ale 0 plati vzdy
	}
	
	gettimeofday(&kon, &tz);

	return count;
}
