#include <iostream>
#include <sys/time.h>
#include "algo.h"
#include "easiest.h"

using namespace std;

wchar_t* Easiest::Uprav_vstup(){
	wchar_t *vstup;
	int index = 0;

	vstup = new wchar_t[l_pattern + l_text + 1];	//pracuje na zretazenom pattern a text
	for (int i = 0; i < l_pattern; i++){
		//MEM_INC();
		vstup[index] = pattern[i];
		index++;
	}

	vstup[index] = '$';
	index++;
	//MEM_INC();

	for (int i = 0; i < l_text; i++){
		//MEM_INC();
		vstup[index] = text[i];
		index++;
	}

	return vstup;
}

int* Easiest::Fundamental(wchar_t* str, wchar_t* patt, int *r, int *l){	//predspracovanie pattern
	int *Zbox, k_prime, beta;
	
	Zbox = new int[l_pattern];	//Z[i]: dlzka najdlhsieho substringu P, ktory konci na poz. i a matchuje prefix P
	for (int i = 0; i< l_pattern; i++) MEM_INC();
	Zbox[0] = l_pattern;
//	MEM_INC();
//	
	//baza
	int i = 0;
	int j = 1;
	while (STEP() && (str[j] == patt[i]) && (i < l_pattern)){
		i++;
		j++;
	}
	Zbox[1] = i;
//	MEM_INC();
	if (Zbox[1] > 0){
		*r = j - 1;
		*l = 1;
	}
	
	//indukcny krok
	int k = 2;
	while (k < l_pattern) {
//		cerr << k << endl;
		if (*r < k) { 			//explicitne porovnavanie
			int i = 0;
			int j = k;
			while (STEP() && (str[j] == patt[i]) && (i < l_pattern)){
				i++;
				j++;
			}
			Zbox[k] = i;  		//vo fundamental spracuvavame iba pattern, takze si pamatame vsetko
//			MEM_INC();
			if (i > 0){
				*r = (j - 1);
				*l = k;
			}
		}
		if (*r >= k) {		//vyuzivame, co uz vieme o pattern	
			k_prime = (k - *l);
			beta = (*r - k + 1);
			if (beta < (Zbox[k_prime] + 1)){		//za r explicitne porovnavame
				i = beta;
				j = (*r + 1);
				while (STEP() && (str[j] == patt[i]) && (i < l_pattern)){
					i++;
					j++;
				}
				if (j >= *r){
					*r = (j - 1);
					*l = k;
				}
				Zbox[k] = (j - k);
//				MEM_INC();
			}
			else {					//dlhsie to nebude
				Zbox[k] = Zbox[k_prime];
//				MEM_INC();
			}
					
		}
		k++;
	}
//	for (int i = 0; i< l_pattern; i++)
//		cerr << "Z[" << i << "]: " << Zbox[i] << endl;
	return Zbox;
}

int Easiest::Match(){
	int *Zbox, count = 0, r = 0,l = 0, k_prime, beta, i,j,k;
	wchar_t *str;

	gettimeofday(&zac, &tz);
	
	str = Uprav_vstup();
	Zbox = Fundamental(pattern,pattern,&r, &l); //v zasade to, co doteraz, ale uz na T, potrebuje l,r, lebo: P$T
	
	k = (l_pattern + 1);				
	while (k <= (l_text + 1)){
		if (r < k) {
			int i = 0;
			int j = k;
			while (STEP() && (str[j] == pattern[i]) && (i < l_pattern)){
				i++;
				j++;
			}
			if (i > 0){
				r = (j - 1);
				l = k;
			}
			if (i == l_pattern)
				count++;
		}
		if (r >= k) {
			k_prime = (k - l);
			beta = (r - k + 1);
			if (beta < (Zbox[k_prime] + 1)){
				i = beta;
				j = (r + 1);
				while (STEP() && (str[j] == pattern[i]) && (i < l_pattern)){
					i++;
					j++;
				}
				if (j > (r + 1)){
					r = (j - 1);
					l = k;
					if ((r - l + 1) == l_pattern)
						count++;
				}
			}
			else if (k < l_pattern){
					Zbox[k] = Zbox[k_prime];
					MEM_INC();
			}
					
		}
		k++;
	}

	gettimeofday(&kon, &tz);
	
	return count;
}
