#include <iostream>
#include <sys/time.h>
#include "algo.h"
#include "easiest.h"
#include "good_suffix.h"

using namespace std;

wchar_t* Good_Suffix::Reverse(){		//Nvalues ziskava pomocou Fundamental, ale na reversnutej pattern, lebo: N_j(P) =					     //Z_{n-j+1}(P-reverse)
	wchar_t *r_pattern;
	r_pattern = new wchar_t[l_pattern+1];

	for (int i = 0; i < l_pattern; i++){
		r_pattern[i] = pattern[l_pattern - i - 1];
	}
	r_pattern[l_pattern] = '\0';
	return r_pattern;
}

int* Good_Suffix::Nvalues(){	     //N[j]: dlzka najdlhsieho suffixu P[1..j], ktory je aj suffix P
	int *Zbox, *Nbox, r=0, l=0;
	wchar_t *r_pattern;
	
	r_pattern = Reverse();
	Zbox = Fundamental(r_pattern,r_pattern,&r, &l);
	Nbox = new int[l_pattern];

	for (int i = 0; i < l_pattern; i++){
		Nbox[i] = Zbox[l_pattern - i - 1];
	}

//	for (int i = 0; i < l_pattern; i++)
//		cerr << "N[" << i << "]: " << Nbox[i] << endl;
	
	delete[] r_pattern;
	delete[] Zbox;

	return Nbox;
}

int* Good_Suffix::Lvalues(){		//L[i]: max pozicia < l_pattern v P taka, ze P[i..n] matchuje suffix P[1..L[i]]
	int *Lbox, *Nbox;		//a zaroven znak pred tymto suffixom nie je = P[i-1]
	Lbox = new int[l_pattern];

	Nbox = Nvalues();
	
	for (int i = 0; i < l_pattern; i++){
		MEM_INC();
		Lbox[i] = 0;
	}
	for (int j = 0; j < (l_pattern - 2); j++){		//max index j < l_pattern, ze N[j] = |P[i..n]| = n-i+1
		int i = (l_pattern - Nbox[j]);
//		cerr << "i: " << i << endl;
		if (i < l_pattern) Lbox[i] = j;
	}
//	for (int i = 0; i < l_pattern; i++)
//		cerr << "L[" << i << "]: " << Lbox[i] << endl;

	delete[] Nbox;

	return Lbox;
}

int* Good_Suffix::lvalues(){		//l[i]: max suffix P[i..n], ktory je aj prefix P 
	int *lbox, *Nbox;
	lbox = new int[l_pattern];

	Nbox = Nvalues();
	for (int i = 0; i < l_pattern; i++) MEM_DEC();

//	cerr << "hi" << endl;
	for (int i = 0; i < l_pattern; i++){
		MEM_INC();
		lbox[i] = -1;
	}
	for (int j = 0; j < l_pattern; j++){		//max index j: N[j] = j+1 a zaroven j<= |P[i..n]|
		if (Nbox[j] == (j+ 1)){
	//		cerr << Nbox[j] << endl;
			int i = l_pattern - Nbox[j];
			lbox[i] = j+1;
		}
	}
	int max = 0;
	for (int i = (l_pattern - 1); i >= 0; i--){
		if (lbox[i] < max)
			 lbox[i] = max;
		else if (lbox[i] > max)
				max = lbox[i];
	}

	delete[] Nbox;

	return lbox;
}

int Good_Suffix::Match(){
	int *Lbox, *lbox, j, i, count = 0;

	gettimeofday(&zac, &tz);
	
	Lbox = Lvalues();
	lbox = lvalues();

	int k = l_pattern - 1;
	while (k < l_text) {
//			cerr << "k: " << k << endl;
			j = k;
			i = (l_pattern - 1);
			while (STEP() && (text[j] == pattern[i]) && (i >= 0)){
				j--;
				i--;
			}
			if (i == l_pattern - 1)		//mismatch na poslednom znaku pattern
				k++;
			else if (Lbox[i + 1] > 0){
				k += (l_pattern - Lbox[i+1] - 1);
			}
			else if (i < 0) {
				count++;
				k += (l_pattern - lbox[1]);
			}
			else {
				k += (l_pattern - lbox[i+1]);
			}
	}
	delete[] Lbox;
	delete[] lbox;

	gettimeofday(&kon, &tz);
	
	return count;
}
