#include <iostream>
#include "algo.h"
#include "easiest.h"
#include "kmp.h"

using namespace std;

int* Kmp::spvalues(){
	int *Zbox, *spbox, i, r = 0, l = 0;
	
	Zbox = Fundamental(pattern,pattern,&r,&l);
	spbox = new int[l_pattern];

	for (i = 0; i < l_pattern; i++){
			MEM_INC();
			spbox[i] = 0;
	}
	for (int j = l_pattern - 1; j > 0; j--){
		i = j + Zbox[j] - 1;
		spbox[i] = Zbox[j];
	}
	delete[] Zbox;

//	for (int i = 0; i < l_pattern; i++)
//		cerr << "sp[" << i << "]: " << spbox[i] << endl;
	return spbox;
}
	
int Kmp::Match(){
	int *spbox, i, k, count = 0;

	gettimeofday(&zac, &tz);
	
	spbox = spvalues();

	k = 0;
	i = 0;
	while (k + (l_pattern - i - 1) < l_text){
		//cerr << "k: " << k <<  "i: " << i << text[k] << " " << pattern[i] << endl;
		while(STEP() && (text[k] == pattern[i]) && (i < l_pattern)){
				k++;
				i++;
		}
		if (i == l_pattern) count++;
		if (i == 0) k++;
		else i = spbox[i-1];
	}
	
	gettimeofday(&kon, &tz);

	return count;
}
		
