#include <iostream>
#include <string>
#include "algo.h"
#include "naive.h"
#include "easiest.h"
#include "good_suffix.h"
#include "bad_character.h"
#include "extended_bc.h"
#include "boyer_moore.h"
#include "kmp.h"
#include "ap_gia_bm.h"
#include "dfa.h"

using namespace std;

int main(int argc, char* argv[]) {
	
	if ((argc == 1) || (argc > 2)){
		cerr << "Invalid number of arguments" << endl;
		cerr << "Usage: ./main <file_name>" << endl;
		return 1;
	}
 
 	if (!setlocale(LC_CTYPE, "")) {
		fprintf(stderr, "Locale not specified. Check LANG, LC_CTYPE, LC_ALL.");
	}


	Naive N;
	N.Nacitaj(argv[1]);
//	N.Vypis();
	cout << "naive: " << N.Match() << endl;
	N.Vypis_zlozitost();

	Easiest E;
	E.Nacitaj(argv[1]);
//	E.Vypis();
	cout << "Easiest: " << E.Match() << endl;
	E.Vypis_zlozitost(); 

	Good_Suffix G;
	G.Nacitaj(argv[1]);
//	G.Vypis();
	cout << "Good_Suffix: " << G.Match() << endl;
	G.Vypis_zlozitost(); 
	
	Bad_character B;
	B.Nacitaj(argv[1]);
	//B.Vypis();
	cout << "Bad_character: " << B.Match() << endl;
	B.Vypis_zlozitost();

	Extended_bc X;
	X.Nacitaj(argv[1]);
	//B.Vypis();
	cout << "Extended_bc: " << X.Match() << endl;
	X.Vypis_zlozitost();
	
	Boyer_Moore M;
	M.Nacitaj(argv[1]);
	cout << "Boyer_Moore: " << M.Match() << endl;
	M.Vypis_zlozitost();  

	Kmp K;
	K.Nacitaj(argv[1]);
	cout << "KMP: " << K.Match() << endl;
	K.Vypis_zlozitost(); 

	Ap_Gia_BM A;
	A.Nacitaj(argv[1]);
	cout << "Apostolico- Giancarlo: " << A.Match() << endl;
	A.Vypis_zlozitost(); 
	
	DFA D;
	D.Nacitaj(argv[1]);
	cout << "Real-Time/DFA: " << D.Match() << endl;
	D.Vypis_zlozitost(); 

	return 0;
}
